﻿using Persistence;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace UnitTests {
  /// <summary>
  ///This is a test class for HeuristicLabUserTest and is intended
  ///to contain all HeuristicLabUserTest Unit Tests
  ///</summary>
  [TestClass()]
  public class HeuristicLabUserTest {
    private TestContext testContextInstance;

    private Persistence.DataClassesDataContext db;

    public HeuristicLabUserTest() {
      db = Persistence.DatabaseUtil.createDataClassesDataContext();
    }

    /// <summary>
    /// creates a local database for all other test methods
    /// </summary>
    [TestMethod()]
    public void createDBTest() {
      if (db.DatabaseExists()) {
        Console.WriteLine("Deleting old database...");
        db.DeleteDatabase();
        Console.WriteLine("Deleted old database!");
      }
      Console.WriteLine("Creating new database...");
      db.CreateDatabase();
      Console.WriteLine("Created new database!");
    }

    /// <summary>
    /// inserts a new user into the database
    /// </summary>
    [TestMethod()]
    public void addUserTest() {
      //Assert.IsNotNull(db);

      //Persistence.HeuristicLabUser user = new HeuristicLabUser();
      //user.UserName = "TEST";
      //db.HeuristicLabUsers.InsertOnSubmit(user);
      //db.SubmitChanges();

//      db.HeuristicLabUsers.
    }

    /// <summary>
    ///Gets or sets the test context which provides
    ///information about and functionality for the current test run.
    ///</summary>
    public TestContext TestContext {
      get {
        return testContextInstance;
      }
      set {
        testContextInstance = value;
      }
    }

    #region Additional test attributes
    // 
    //You can use the following additional attributes as you write your tests:
    //
    //Use ClassInitialize to run code before running the first test in the class
    //[ClassInitialize()]
    //public static void MyClassInitialize(TestContext testContext)
    //{
    //}
    //
    //Use ClassCleanup to run code after all tests in a class have run
    //[ClassCleanup()]
    //public static void MyClassCleanup()
    //{
    //}
    //
    //Use TestInitialize to run code before running each test
    //[TestInitialize()]
    //public void MyTestInitialize()
    //{
    //}
    //
    //Use TestCleanup to run code after each test has run
    //[TestCleanup()]
    //public void MyTestCleanup()
    //{
    //}
    //
    #endregion


    /// <summary>
    ///A test for UserName
    ///</summary>
    [TestMethod()]
    public void UserNameTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string actual;
      actual = target.UserName;
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for PasswordQuestion
    ///</summary>
    [TestMethod()]
    public void PasswordQuestionTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string actual;
      actual = target.PasswordQuestion;
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for PasswordAnswer
    ///</summary>
    [TestMethod()]
    public void PasswordAnswerTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      target.PasswordAnswer = expected;
      actual = target.PasswordAnswer;
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for Password
    ///</summary>
    [TestMethod()]
    public void PasswordTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      target.Password = expected;
      actual = target.Password;
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for LastPasswordChangedDate
    ///</summary>
    [TestMethod()]
    public void LastPasswordChangedDateTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      DateTime actual;
      actual = target.LastPasswordChangedDate;
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for Email
    ///</summary>
    [TestMethod()]
    public void EmailTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      target.Email = expected;
      actual = target.Email;
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for Comment
    ///</summary>
    [TestMethod()]
    public void CommentTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      target.Comment = expected;
      actual = target.Comment;
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for UnlockUser
    ///</summary>
    [TestMethod()]
    public void UnlockUserTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      bool expected = false; // TODO: Initialize to an appropriate value
      bool actual;
      actual = target.UnlockUser();
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for ToString
    ///</summary>
    [TestMethod()]
    public void ToStringTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      actual = target.ToString();
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for SendPropertyChanging
    ///</summary>
    [TestMethod()]
    [DeploymentItem("Persistence.dll")]
    public void SendPropertyChangingTest() {
      HeuristicLabUser_Accessor target = new HeuristicLabUser_Accessor(); // TODO: Initialize to an appropriate value
      target.SendPropertyChanging();
      Assert.Inconclusive("A method that does not return a value cannot be verified.");
    }

    /// <summary>
    ///A test for SendPropertyChanged
    ///</summary>
    [TestMethod()]
    [DeploymentItem("Persistence.dll")]
    public void SendPropertyChangedTest() {
      HeuristicLabUser_Accessor target = new HeuristicLabUser_Accessor(); // TODO: Initialize to an appropriate value
      string propertyName = string.Empty; // TODO: Initialize to an appropriate value
      target.SendPropertyChanged(propertyName);
      Assert.Inconclusive("A method that does not return a value cannot be verified.");
    }

    /// <summary>
    ///A test for ResetPassword
    ///</summary>
    [TestMethod()]
    public void ResetPasswordTest1() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      actual = target.ResetPassword();
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for ResetPassword
    ///</summary>
    [TestMethod()]
    public void ResetPasswordTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string passwordAnswer = string.Empty; // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      actual = target.ResetPassword(passwordAnswer);
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for GetPassword
    ///</summary>
    [TestMethod()]
    public void GetPasswordTest1() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string passwordAnswer = string.Empty; // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      actual = target.GetPassword(passwordAnswer);
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for GetPassword
    ///</summary>
    [TestMethod()]
    public void GetPasswordTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string expected = string.Empty; // TODO: Initialize to an appropriate value
      string actual;
      actual = target.GetPassword();
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for ChangePasswordQuestionAndAnswer
    ///</summary>
    [TestMethod()]
    public void ChangePasswordQuestionAndAnswerTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string password = string.Empty; // TODO: Initialize to an appropriate value
      string newPasswordQuestion = string.Empty; // TODO: Initialize to an appropriate value
      string newPasswordAnswer = string.Empty; // TODO: Initialize to an appropriate value
      bool expected = false; // TODO: Initialize to an appropriate value
      bool actual;
      actual = target.ChangePasswordQuestionAndAnswer(password, newPasswordQuestion, newPasswordAnswer);
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for ChangePassword
    ///</summary>
    [TestMethod()]
    public void ChangePasswordTest() {
      HeuristicLabUser target = new HeuristicLabUser(); // TODO: Initialize to an appropriate value
      string oldPassword = string.Empty; // TODO: Initialize to an appropriate value
      string newPassword = string.Empty; // TODO: Initialize to an appropriate value
      bool expected = false; // TODO: Initialize to an appropriate value
      bool actual;
      actual = target.ChangePassword(oldPassword, newPassword);
      Assert.AreEqual(expected, actual);
      Assert.Inconclusive("Verify the correctness of this test method.");
    }

    /// <summary>
    ///A test for HeuristicLabUser Constructor
    ///</summary>
    [TestMethod()]
    public void HeuristicLabUserConstructorTest() {
      HeuristicLabUser target = new HeuristicLabUser();
      Assert.Inconclusive("TODO: Implement code to verify target");
    }
  }
}
